"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEmpty = void 0;
const Observable_js_1 = require("../Observable.js");
function isEmpty() {
    return (source) => new Observable_js_1.Observable((destination) => {
        source.subscribe((0, Observable_js_1.operate)({
            destination,
            next: () => {
                destination.next(false);
                destination.complete();
            },
            complete: () => {
                destination.next(true);
                destination.complete();
            },
        }));
    });
}
exports.isEmpty = isEmpty;
//# sourceMappingURL=isEmpty.js.map